public class Ball extends Disk
{
    private double deltaX;
    private double deltaY;

    public Ball( int x, int y, int r, double dx, double dy )
    {
        super( x, y, r );
        deltaX = dx;
        deltaY = dy;
    }

    public void move()
    {
        moveBy( (int) deltaX, (int) deltaY );
    }

    // access methods

    protected void adjustSpeedBy( double ddx, double ddy )
    {
        deltaX += ddx;
        deltaY += ddy;
    }

    protected void adjustSpeedBy( double factor )
    {
        deltaX += (deltaX * factor);
        deltaY += (deltaY * factor);
    }

    protected void reverseDeltaX()
    {
        deltaX *= -1;
    }

    protected void reverseDeltaY()
    {
        deltaY *= -1;
    }
}
